# Book PDFs module, this module prints an entire book including all subsections into one PDF document using the php DomPDF library.

## Advantage to using the book_pdfs project instead of the book_pdf project.

The book_pdfs project uses the php library called DomPDF.  This does not require a server binary like some other pdf libraries require.
Alpine based docker systems have no problem using the dompdf library because it only requires php as a dependency which is already required by Drupal.

# PDF Theming in Drupal

To get more control of the PDF-generated HTML, start by enabling theme debugging in your `sites/default/services.yml`.

## Steps

1. Add the following code:

    ```php
    echo print_r($bookHtml, TRUE);
    die;
    ```

    in `modules/contrib/book_pdfs/src/EventSubscriber/BookPdfsPreGenerateSubscriber.php`, just after `$bookHtml` is instantiated in the code.

2. Rebuild caches.

3. You'll need to search for the theme debugging in the rendered output. For example, my theme was coming from a parent theme and was `node.html.twig`.

4. There are several theming suggestions. One of them is `node--book--print.html.twig`.

5. I modified the twig as desired.

6. There is another twig that I also modified, and this one is provided by core:

    ```php
    core/modules/book/templates/book-node-export-html.html.twig
    ```

7. There were no theme suggestions available, so I copied this file to my custom theme `templates/book` folder.

8. I modified this twig by removing the `H1` in the template.

## Conclusion

Adjust your twig templates as needed.

## Optional enhancements / bugfixes are available

 - In progress
